## gemmi 0.4.9+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0 FATAL_ERROR)
project(gemmi C CXX)

option(USE_FORTRAN "Build Fortran bindings" OFF)
option(USE_PYTHON "Build Python bindings" OFF)
option(INSTALL_EGG_INFO "Install .egg-info via setup.py" ON)
option(EXTRA_WARNINGS "Set extra warning flags" OFF)
option(USE_WMAIN "(Windows only) take Unicode arguments in gemmi program" ON)

if (DEFINED ENV{FC} OR CMAKE_Fortran_COMPILER)
  set(USE_FORTRAN ON CACHE BOOL "Build Fortran bindings" FORCE)
endif()

if (INFO)
  set(GEMMI_VERSION_INFO ${INFO} CACHE STRING "Extra text for gemmi -V" FORCE)
endif()

if (USE_FORTRAN)
  enable_language(Fortran)
else()
  message(STATUS "Skipping Fortran bindings. Add -D USE_FORTRAN=1 to build them.")
endif()

if (DEFINED ENV{EXTRA_WFLAGS})
  set(EXTRA_WARNINGS ON CACHE BOOL "Set extra warning flags" FORCE)
endif()

if (NOT CMAKE_CXX_STANDARD)
  if (CMAKE_CXX17_STANDARD_COMPILE_OPTION)
    # Python bindings don't compile as C++17 in VS 2017
    if (CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
      set(CMAKE_CXX_STANDARD 14)
    else()
      set(CMAKE_CXX_STANDARD 17)
    endif()
  elseif (CMAKE_CXX11_STANDARD_COMPILE_OPTION)
    set(CMAKE_CXX_STANDARD 11)
  endif()
endif()
message(STATUS "Compiling with C++ standard: ${CMAKE_CXX_STANDARD}")
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

include(CheckIncludeFile)

if (DEFINED ENV{CXXFLAGS})
  set(USING_ENV_CXXFLAGS ON CACHE BOOL "" FORCE)
endif()

# Set default build mode (based on CMake FAQ)
if (NOT CMAKE_BUILD_TYPE AND NOT USING_ENV_CXXFLAGS)
  set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
endif()

# avoid CMake warning about unset policy
if (POLICY CMP0074)
  cmake_policy(SET CMP0074 NEW)
endif()
if (POLICY CMP0069)
  cmake_policy(SET CMP0069 NEW)
endif()

find_package(ZLIB)
if (ZLIB_FOUND)
  include_directories("${ZLIB_INCLUDE_DIR}")
else()
  message(STATUS "The build will use zlib code from third_party/zlib.")
  include_directories("${CMAKE_SOURCE_DIR}/third_party/zlib")
endif()
find_package(benchmark QUIET)
if (benchmark_FOUND)
  message(STATUS "Found benchmark: ${benchmark_DIR}")
else (NOT benchmark_FOUND)
  message(STATUS "Benchmarks not configured.")
endif()

include_directories("${CMAKE_SOURCE_DIR}/include"
                    "${CMAKE_SOURCE_DIR}/third_party")

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang|GNU" AND EXTRA_WARNINGS)
  set(CMAKE_CXX_FLAGS
      "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wpedantic -Wformat=2 -Wredundant-decls -Wfloat-conversion -Wdisabled-optimization -Wshadow $ENV{EXTRA_WFLAGS}")
  message(STATUS "Build type: ${CMAKE_BUILD_TYPE}")
  string(TOUPPER "CMAKE_CXX_FLAGS_${CMAKE_BUILD_TYPE}" cxx_flags_config)
  message(STATUS "C++ flags set to: ${CMAKE_CXX_FLAGS} ${${cxx_flags_config}}")
endif()

if (CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
  #set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /Qvec-report:1")
endif()

if (USE_FORTRAN)
  if (CMAKE_Fortran_COMPILER_ID MATCHES "GNU")
    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -std=f2003 -fimplicit-none -Wall -Wextra -pedantic")
    message(STATUS "Fortran flags set to: ${CMAKE_Fortran_FLAGS}")
    set(CMAKE_Fortran_FLAGS_DEBUG "${CMAKE_Fortran_FLAGS_DEBUG} -fbounds-check")
  endif()
endif()


if (ZLIB_FOUND)
  macro(support_gz exe)
    target_link_libraries(${exe} PRIVATE ZLIB::ZLIB)
  endmacro()
else()
  add_library(ungz OBJECT
      "third_party/zlib/adler32.c"
      "third_party/zlib/crc32.c"
      "third_party/zlib/gzlib.c"
      "third_party/zlib/gzread.c"
      "third_party/zlib/inflate.c"
      "third_party/zlib/inftrees.c"
      "third_party/zlib/inffast.c"
      "third_party/zlib/zutil.c")
  check_include_file(unistd.h has_unistd_h)
  target_compile_definitions(ungz PRIVATE NO_GZCOMPRESS=1)
  if (has_unistd_h)
    target_compile_definitions(ungz PRIVATE Z_HAVE_UNISTD_H=1)
  endif()
  if (CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
    # /wd4996 - the POSIX name for this item is deprecated.
    # /wd4267 - conversion from 'size_t' to 'unsigned int', possible loss of data
    target_compile_options(ungz PRIVATE /wd4996 /wd4267)
  endif()
  if (USE_PYTHON)
    set_property(TARGET ungz PROPERTY POSITION_INDEPENDENT_CODE ON)
  endif()
  macro(support_gz exe)
    target_sources(${exe} PUBLIC $<TARGET_OBJECTS:ungz>)
  endmacro()
endif()

if (WIN32 AND USE_WMAIN)
  add_definitions(-D_UNICODE=1)
endif()

#add_library(cgemmi STATIC fortran/grid.cpp fortran/symmetry.cpp)
#
#if (USE_FORTRAN)
#  add_library(fgemmi STATIC fortran/gemmi.f90)
#  target_link_libraries(fgemmi PRIVATE cgemmi)
#endif()


### programs from src/ ###

add_library(input OBJECT src/input.cpp)
add_library(options OBJECT src/options.cpp)
if (GEMMI_VERSION_INFO)
  target_compile_definitions(options PRIVATE GEMMI_VERSION_INFO=${GEMMI_VERSION_INFO})
endif()
add_library(output OBJECT src/output.cpp)
add_library(mapcoef OBJECT src/mapcoef.cpp)

add_executable(gemmi-align EXCLUDE_FROM_ALL $<TARGET_OBJECTS:options>
               src/align.cpp $<TARGET_OBJECTS:input>)
support_gz(gemmi-align)

add_executable(gemmi-blobs EXCLUDE_FROM_ALL $<TARGET_OBJECTS:options>
               src/blobs.cpp $<TARGET_OBJECTS:mapcoef> $<TARGET_OBJECTS:input>)
support_gz(gemmi-blobs)

add_executable(gemmi-cif2json EXCLUDE_FROM_ALL $<TARGET_OBJECTS:options>
               src/cif2json.cpp $<TARGET_OBJECTS:input>)
support_gz(gemmi-cif2json)

add_executable(gemmi-cif2mtz EXCLUDE_FROM_ALL $<TARGET_OBJECTS:options>
               src/cif2mtz.cpp $<TARGET_OBJECTS:input>)
support_gz(gemmi-cif2mtz)

add_executable(gemmi-contact EXCLUDE_FROM_ALL $<TARGET_OBJECTS:options>
               src/contact.cpp $<TARGET_OBJECTS:input>)
support_gz(gemmi-contact)

add_executable(gemmi-contents EXCLUDE_FROM_ALL $<TARGET_OBJECTS:options>
               src/contents.cpp $<TARGET_OBJECTS:input>)
support_gz(gemmi-contents)

add_executable(gemmi-convert EXCLUDE_FROM_ALL $<TARGET_OBJECTS:options>
               src/convert.cpp $<TARGET_OBJECTS:output> $<TARGET_OBJECTS:input>)
support_gz(gemmi-convert)

add_executable(gemmi-crdrst EXCLUDE_FROM_ALL $<TARGET_OBJECTS:options>
               src/crdrst.cpp $<TARGET_OBJECTS:output>
               $<TARGET_OBJECTS:input>)
support_gz(gemmi-crdrst)

add_executable(gemmi-fprime EXCLUDE_FROM_ALL $<TARGET_OBJECTS:options>
               src/fprime.cpp)

add_executable(gemmi-grep EXCLUDE_FROM_ALL $<TARGET_OBJECTS:options>
               src/grep.cpp)
support_gz(gemmi-grep)

add_executable(gemmi-h EXCLUDE_FROM_ALL $<TARGET_OBJECTS:options>
               src/h.cpp $<TARGET_OBJECTS:output> $<TARGET_OBJECTS:input>)
support_gz(gemmi-h)

add_executable(gemmi-json2cif EXCLUDE_FROM_ALL $<TARGET_OBJECTS:options>
               src/json2cif.cpp $<TARGET_OBJECTS:input>)
support_gz(gemmi-json2cif)

add_executable(gemmi-map EXCLUDE_FROM_ALL $<TARGET_OBJECTS:options>
               src/map.cpp $<TARGET_OBJECTS:input>)
support_gz(gemmi-map)

add_executable(gemmi-map2sf EXCLUDE_FROM_ALL $<TARGET_OBJECTS:options>
               src/map2sf.cpp $<TARGET_OBJECTS:input>)
support_gz(gemmi-map2sf)

add_executable(gemmi-mask EXCLUDE_FROM_ALL $<TARGET_OBJECTS:options>
               src/mask.cpp $<TARGET_OBJECTS:input>)
support_gz(gemmi-mask)

add_executable(gemmi-mixmtz EXCLUDE_FROM_ALL $<TARGET_OBJECTS:options>
               src/mixmtz.cpp $<TARGET_OBJECTS:output>)

add_executable(gemmi-merge EXCLUDE_FROM_ALL $<TARGET_OBJECTS:options>
               src/merge.cpp $<TARGET_OBJECTS:input>)
support_gz(gemmi-merge)

add_executable(gemmi-mondiff EXCLUDE_FROM_ALL $<TARGET_OBJECTS:options>
               src/mondiff.cpp $<TARGET_OBJECTS:input>)
support_gz(gemmi-mondiff)

add_executable(gemmi-mtz EXCLUDE_FROM_ALL $<TARGET_OBJECTS:options>
               src/mtz.cpp)
support_gz(gemmi-mtz)

add_executable(gemmi-mtz2cif EXCLUDE_FROM_ALL $<TARGET_OBJECTS:options>
               src/mtz2cif.cpp)
support_gz(gemmi-mtz2cif)

add_executable(gemmi-reindex EXCLUDE_FROM_ALL $<TARGET_OBJECTS:options>
               src/reindex.cpp)
support_gz(gemmi-reindex)

add_executable(gemmi-residues EXCLUDE_FROM_ALL $<TARGET_OBJECTS:options>
               src/residues.cpp $<TARGET_OBJECTS:input>)
support_gz(gemmi-residues)

add_executable(gemmi-rmsz EXCLUDE_FROM_ALL $<TARGET_OBJECTS:options>
               src/rmsz.cpp $<TARGET_OBJECTS:input>)
support_gz(gemmi-rmsz)

add_executable(gemmi-sf2map EXCLUDE_FROM_ALL $<TARGET_OBJECTS:options>
               src/sf2map.cpp $<TARGET_OBJECTS:mapcoef> $<TARGET_OBJECTS:input>)
support_gz(gemmi-sf2map)

add_executable(gemmi-sfcalc EXCLUDE_FROM_ALL $<TARGET_OBJECTS:options>
               src/sfcalc.cpp $<TARGET_OBJECTS:input> $<TARGET_OBJECTS:output>)
support_gz(gemmi-sfcalc)

add_executable(gemmi-sg EXCLUDE_FROM_ALL $<TARGET_OBJECTS:options>
               src/sg.cpp)

add_executable(gemmi-tags EXCLUDE_FROM_ALL $<TARGET_OBJECTS:options>
               src/tags.cpp)
support_gz(gemmi-tags)

add_executable(gemmi-validate EXCLUDE_FROM_ALL $<TARGET_OBJECTS:options>
               src/validate.cpp src/validate_mon.cpp)
support_gz(gemmi-validate)

add_executable(gemmi-wcn EXCLUDE_FROM_ALL $<TARGET_OBJECTS:options>
               src/wcn.cpp $<TARGET_OBJECTS:input>)
support_gz(gemmi-wcn)

add_executable(gemmi-prog
               src/align.cpp src/blobs.cpp
               src/cif2mtz.cpp src/cif2json.cpp src/contact.cpp
               src/contents.cpp src/convert.cpp src/fprime.cpp
               src/grep.cpp src/h.cpp src/json2cif.cpp
               src/main.cpp src/map.cpp src/map2sf.cpp src/mask.cpp
               src/merge.cpp src/mondiff.cpp src/mtz.cpp src/mtz2cif.cpp
               src/reindex.cpp src/residues.cpp src/rmsz.cpp
               src/sf2map.cpp src/sfcalc.cpp src/sg.cpp
               src/tags.cpp src/validate.cpp src/validate_mon.cpp src/wcn.cpp
               $<TARGET_OBJECTS:mapcoef>
               $<TARGET_OBJECTS:input>
               $<TARGET_OBJECTS:output>
               $<TARGET_OBJECTS:options>)
support_gz(gemmi-prog)
target_compile_definitions(gemmi-prog PRIVATE GEMMI_ALL_IN_ONE=1)
set_target_properties(gemmi-prog PROPERTIES OUTPUT_NAME gemmi)
if (WIN32 AND USE_WMAIN)
  # _UNICODE=1 is now set globally
  #target_compile_definitions(gemmi-prog PRIVATE _UNICODE=1)
  if(MINGW)
    # target_link_options were added in cmake 3.13
    set_target_properties(gemmi-prog PROPERTIES LINK_FLAGS "-municode")
  endif()
endif()

### tests and examples ###

#add_executable(c_test EXCLUDE_FROM_ALL fortran/c_test.c)
#target_link_libraries(c_test PRIVATE cgemmi)

add_executable(cpptest EXCLUDE_FROM_ALL tests/main.cpp tests/cif.cpp)

add_executable(hello EXCLUDE_FROM_ALL examples/hello.cpp)
add_executable(doc_example EXCLUDE_FROM_ALL
               docs/code/sym.cpp docs/code/elem.cpp docs/code/resinfo.cpp
               docs/code/cell.cpp)
add_executable(doc_example2 EXCLUDE_FROM_ALL docs/code/cif_cc.cpp)
add_executable(doc_maybegz EXCLUDE_FROM_ALL
               docs/code/maybegz.cpp
               docs/code/mutate.cpp)
support_gz(doc_maybegz)
add_executable(doc_newmtz EXCLUDE_FROM_ALL docs/code/newmtz.cpp)

# always compile these tests with assertions enabled
if (CMAKE_CXX_COMPILER_ID MATCHES "Clang|GNU|Intel")
  target_compile_options(doc_example PRIVATE -UNDEBUG)
endif()

add_executable(test_disulf EXCLUDE_FROM_ALL tests/disulf.cpp)
support_gz(test_disulf)

# auth_label requires <experimental/filesystem> and -lstdc++fs
add_executable(auth_label EXCLUDE_FROM_ALL examples/auth_label.cpp)
if (NOT MSVC)
  target_link_libraries(auth_label PRIVATE stdc++fs)
endif()
support_gz(auth_label)

add_executable(check_conn EXCLUDE_FROM_ALL examples/check_conn.cpp)
support_gz(check_conn)

enable_testing()

add_custom_target(print-version
  COMMAND gemmi-prog --version
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMENT "gemmi --version"
)

add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND} -C $<CONFIGURATION>)

=== debian/changelog ===
gemmi (0.4.9+ds-1) unstable; urgency=medium

  * New upstream version 0.4.9+ds
  * Dropping use-system-stb.patch: issue resolved upstream.

 -- Andrius Merkys <merkys@debian.org>  Mon, 27 Sep 2021 01:55:26 -0400

gemmi (0.4.8+ds-1) unstable; urgency=medium

  * New upstream version 0.4.8+ds (Closes: #992932)
  * Dropping unneeded use-system-zlib.patch.
  * Turning off production of gemmi.egg-info.

 -- Andrius Merkys <merkys@debian.org>  Thu, 26 Aug 2021 09:07:23 -0400

gemmi (0.4.7+ds-1) unstable; urgency=medium

  * New upstream version 0.4.7+ds
  * Adding Upstream-Contact.
  * Refreshing patches.

 -- Andrius Merkys <merkys@debian.org>  Sun, 22 Aug 2021 03:38:01 -0400

gemmi (0.4.5+ds-1) unstable; urgency=medium

  * Initial release (Closes: #986781)

 -- Andrius Merkys <merkys@debian.org>  Fri, 09 Apr 2021 00:47:32 -0400

=== debian/control ===
Source: gemmi
Section: science
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders:
 Andrius Merkys <merkys@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dh-python,
 help2man,
 libstb-dev,
 python3-dev,
 python3-pybind11 (>= 2.6.0),
 tao-pegtl-dev,
 zlib1g-dev,
Standards-Version: 4.5.1
Homepage: https://project-gemmi.github.io
Vcs-Browser: https://salsa.debian.org/debichem-team/gemmi
Vcs-Git: https://salsa.debian.org/debichem-team/gemmi.git
Rules-Requires-Root: no

Package: gemmi
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: library for structural biology - executable
 Library for macromolecular crystallography and structural bioinformatics. For
 working with coordinate files (mmCIF, PDB, mmJSON), refinement restraints
 (monomer library), electron density maps (CCP4), and crystallographic
 reflection data (MTZ, SF-mmCIF). It understands crystallographic symmetries,
 it knows how to switch between the real and reciprocal space and it can do a
 few other things.
 .
 This package contains main gemmi executable.

Package: gemmi-dev
Architecture: any
Section: libdevel
Depends:
 ${misc:Depends},
Description: library for structural biology
 Library for macromolecular crystallography and structural bioinformatics. For
 working with coordinate files (mmCIF, PDB, mmJSON), refinement restraints
 (monomer library), electron density maps (CCP4), and crystallographic
 reflection data (MTZ, SF-mmCIF). It understands crystallographic symmetries,
 it knows how to switch between the real and reciprocal space and it can do a
 few other things.
 .
 This package contains header-only C++ library.

Package: python3-gemmi
Architecture: any
Section: python
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Provides:
 ${python3:Provides},
XS-Python-Version: ${python3:Versions}
Description: library for structural biology - Python module
 Library for macromolecular crystallography and structural bioinformatics. For
 working with coordinate files (mmCIF, PDB, mmJSON), refinement restraints
 (monomer library), electron density maps (CCP4), and crystallographic
 reflection data (MTZ, SF-mmCIF). It understands crystallographic symmetries,
 it knows how to switch between the real and reciprocal space and it can do a
 few other things.
 .
 This package contains the Python module.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export PYBUILD_NAME=gemmi

%:
	dh $@ --buildsystem=cmake --with python3

override_dh_auto_configure:
	rm -rf include/gemmi/third_party/tao include/gemmi/third_party/stb_sprintf.h third_party/zlib
	dh_auto_configure -- -DUSE_PYTHON=1 -DINSTALL_EGG_INFO=OFF

override_dh_auto_test:
	dh_auto_build -- check

override_dh_installman: debian/gemmi.1
	dh_installman

debian/gemmi.1:
	help2man 'tail -n +9 docs/gemmi-help.txt' \
		--version-string $(DEB_VERSION_UPSTREAM) --name 'CLI for GEMMI library' \
		--no-info --help-option '' > $@
	sed -i 's/.TH GEMMI-HELP.TXT/.TH gemmi/' $@
	sed -i 's/gemmi-help.txt/gemmi/' $@

## gemmi 0.5.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,6 +6,9 @@
 option(INSTALL_EGG_INFO "Install .egg-info via setup.py" ON)
 option(EXTRA_WARNINGS "Set extra warning flags" OFF)
 option(USE_WMAIN "(Windows only) take Unicode arguments in gemmi program" ON)
+
+# uncomment to show compilation times for each compilation unit
+#set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "\"${CMAKE_COMMAND}\" -E time")
 
 if (DEFINED ENV{FC} OR CMAKE_Fortran_COMPILER)
   set(USE_FORTRAN ON CACHE BOOL "Build Fortran bindings" FORCE)
@@ -233,7 +236,7 @@
 support_gz(gemmi-mtz)
 
 add_executable(gemmi-mtz2cif EXCLUDE_FROM_ALL $<TARGET_OBJECTS:options>
-               src/mtz2cif.cpp)
+               src/mtz2cif.cpp $<TARGET_OBJECTS:input> $<TARGET_OBJECTS:output>)
 support_gz(gemmi-mtz2cif)
 
 add_executable(gemmi-reindex EXCLUDE_FROM_ALL $<TARGET_OBJECTS:options>
@@ -336,9 +339,3 @@
 enable_testing()
 
 add_custom_target(print-version
-  COMMAND gemmi-prog --version
-  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
-  COMMENT "gemmi --version"
-)
-
-add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND} -C $<CONFIGURATION>)

=== debian/changelog ===
gemmi (0.5.0+ds-1) unstable; urgency=medium

  * New upstream version 0.5.0+ds
  * Removing license of already removed component.
  * Cleaning up debian/rules.
  * Changing error type in test via patch.
  * Adding autopkgtest.
  * Running Python tests during build.
  * Wrapping and sorting.

 -- Andrius Merkys <merkys@debian.org>  Wed, 10 Nov 2021 07:39:22 -0500

=== debian/control ===
--- 
+++ 
@@ -12,6 +12,7 @@
  libstb-dev,
  python3-dev,
  python3-pybind11 (>= 2.6.0),
+ python3-pytest <!nocheck>,
  tao-pegtl-dev,
  zlib1g-dev,
 Standards-Version: 4.5.1

## gemmi 0.5.1+ds

=== debian/changelog ===
gemmi (0.5.1+ds-1build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 as default version

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 13 Jan 2022 19:16:30 +0000

gemmi (0.5.1+ds-1) unstable; urgency=medium

  [ Andrius Merkys ]
  * New upstream version 0.5.1+ds
  * Refreshing use-system-tao-pegtl.patch.

  [ lintian-brush ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit.
  * Update standards version to 4.6.0, no changes needed.

 -- Andrius Merkys <merkys@debian.org>  Tue, 14 Dec 2021 02:18:36 -0500

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
  python3-pytest <!nocheck>,
  tao-pegtl-dev,
  zlib1g-dev,
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Homepage: https://project-gemmi.github.io
 Vcs-Browser: https://salsa.debian.org/debichem-team/gemmi
 Vcs-Git: https://salsa.debian.org/debichem-team/gemmi.git

## gemmi 0.5.2+ds

=== debian/changelog ===
gemmi (0.5.2+ds-2ubuntu3) jammy; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - Make gemmi build by patching build system to install files into
      /usr/local/lib (dh_python3 will move them into /usr/lib) after dh_install.
    - Pybind11 requires more fixes (see: #1006615)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 10 Mar 2022 08:57:08 +0100

gemmi (0.5.2+ds-2) unstable; urgency=medium

  * Using system-provided doctest (Closes: #1006980).
    Thanks Gianfranco Costamagna.

 -- Andrius Merkys <merkys@debian.org>  Thu, 10 Mar 2022 00:50:09 -0500

gemmi (0.5.2+ds-1ubuntu1) jammy; urgency=medium

  * debian/patches/8ee91f37ba27397ef5eeedd2e542a4aaaa33ddc1.patch:
    - cherry-pick upstream fix in doctest repo for new glibc
    - NOTE: a proper fix is to start using system doctest-dev repository,
      something that has been requested with a Debian bug and patch:
      (Closes: #1006980)
  * Make gemmi build by patching build system to install files into
    /usr/local/lib (dh_python3 will move them into /usr/lib) after dh_install.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 09 Mar 2022 21:00:16 +0100

gemmi (0.5.2+ds-1) unstable; urgency=medium

  * New upstream version 0.5.2+ds
  * Refreshing change_error_type_in_test.patch.
  * Bumping copyright years.

 -- Andrius Merkys <merkys@debian.org>  Thu, 27 Jan 2022 04:16:18 -0500

## gemmi 0.5.3%2Bds

=== CMakeLists.txt ===
--- 
+++ 
@@ -274,7 +274,7 @@
                src/wcn.cpp $<TARGET_OBJECTS:input>)
 support_gz(gemmi-wcn)
 
-add_executable(gemmi-prog
+add_executable(program
                src/align.cpp src/blobs.cpp
                src/cif2mtz.cpp src/cif2json.cpp src/contact.cpp
                src/contents.cpp src/convert.cpp src/fprime.cpp
@@ -288,15 +288,15 @@
                $<TARGET_OBJECTS:input>
                $<TARGET_OBJECTS:output>
                $<TARGET_OBJECTS:options>)
-support_gz(gemmi-prog)
-target_compile_definitions(gemmi-prog PRIVATE GEMMI_ALL_IN_ONE=1)
-set_target_properties(gemmi-prog PROPERTIES OUTPUT_NAME gemmi)
+support_gz(program)
+target_compile_definitions(program PRIVATE GEMMI_ALL_IN_ONE=1)
+set_target_properties(program PROPERTIES OUTPUT_NAME gemmi)
 if (WIN32 AND USE_WMAIN)
   # _UNICODE=1 is now set globally
-  #target_compile_definitions(gemmi-prog PRIVATE _UNICODE=1)
+  #target_compile_definitions(program PRIVATE _UNICODE=1)
   if(MINGW)
     # target_link_options were added in cmake 3.13
-    set_target_properties(gemmi-prog PROPERTIES LINK_FLAGS "-municode")
+    set_target_properties(program PROPERTIES LINK_FLAGS "-municode")
   endif()
 endif()

## gemmi 0.5.3+ds

=== c_fortran/Makefile ===
# includes part of shroud/regression/run/defaults.mk

SUFFIX = -10
CC = gcc$(SUFFIX)
CXX = g++$(SUFFIX)
FC = gfortran$(SUFFIX)

CFLAGS = -O -Wall -Wstrict-prototypes -fno-strict-aliasing -std=c99
FFLAGS = -O -cpp -std=f2003 -ffree-form -Wall -fbounds-check
CXXFLAGS = -O -Wall -std=c++11 -fno-strict-aliasing
INCLUDE = -I../include
FLIBS = -lstdc++ -lz

C_OBJS = \
    wrapPosition.o \
    wrapFractional.o \
    wrapUnitCell.o \
    wrapSpaceGroup.o \
    wrapGroupOps.o \
    wrapOp.o \
    wrapCcp4_float.o \
    wrapCcp4_int8_t.o \
    wrapMtz.o \
    wrapgemmi.o \
    utilgemmi.o

F_OBJS = wrapfgemmi.o

TEST_PROGS = ftest fsym

all: $(TEST_PROGS)

clean:
	rm -f $(TEST_PROGS) *.a *.o *.mod
	rm -f wrap* types*.h util*.cpp *.json *.log gemmi_types.yaml

$(C_OBJS:.o=.cpp) $(F_OBJS:.o=.f): gemmi.yaml
	shroud gemmi.yaml

%.o: %.cpp
	$(CXX) $(CXXFLAGS) $(INCLUDE) -c $<

%.o %.mod: %.f
	$(FC) $(FFLAGS) $(INCLUDE) -c $<

%.o: %.f90 wrapfgemmi.o
	$(FC) $(FFLAGS) $(INCLUDE) -c $<

gemmi.a: $(C_OBJS) $(F_OBJS) write.o
	ar rcs gemmi.a $^

ftest: ftest.o gemmi.a
	$(FC) $(FFLAGS) $^ -o $@ $(FLIBS)

fsym: fsym.o gemmi.a
	$(FC) $(FFLAGS) $^ -o $@ $(FLIBS)

.PHONY: clean all

=== debian/changelog ===
gemmi (0.5.3+ds-2) unstable; urgency=medium

  * Fix Python install path.

 -- Andrius Merkys <merkys@debian.org>  Mon, 28 Mar 2022 11:05:30 -0400

gemmi (0.5.3+ds-1) unstable; urgency=medium

  * New upstream version 0.5.3+ds
  * Exclude third_party/doctest.h.
  * Refresh use-system-tao-pegtl.patch.

 -- Andrius Merkys <merkys@debian.org>  Fri, 18 Mar 2022 08:49:11 -0400

=== debian/control ===
--- 
+++ 
@@ -8,6 +8,7 @@
  cmake,
  debhelper-compat (= 13),
  dh-python,
+ doctest-dev,
  help2man,
  libstb-dev,
  python3-dev,

=== debian/rules ===
--- 
+++ 
@@ -8,11 +8,11 @@
 	dh $@ --buildsystem=cmake --with python3
 
 override_dh_auto_configure:
-	rm -rf include/gemmi/third_party/tao include/gemmi/third_party/stb_sprintf.h third_party/zlib
 	dh_auto_configure -- -DUSE_PYTHON=1 -DINSTALL_EGG_INFO=OFF
 
 override_dh_auto_test:
 	dh_auto_build -- check
+	PYTHONPATH=$$(find . -name 'obj-*') pytest-3
 
 override_dh_installman: debian/gemmi.1
 	dh_installman

=== debian/tests/control ===
Test-Command: pytest-3
Depends:
 python3-gemmi,
 python3-pytest,

## gemmi 0.5.4+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -188,11 +188,6 @@
                src/convert.cpp $<TARGET_OBJECTS:output> $<TARGET_OBJECTS:input>)
 support_gz(gemmi-convert)
 
-add_executable(gemmi-crdrst EXCLUDE_FROM_ALL $<TARGET_OBJECTS:options>
-               src/crdrst.cpp $<TARGET_OBJECTS:output>
-               $<TARGET_OBJECTS:input>)
-support_gz(gemmi-crdrst)
-
 add_executable(gemmi-fprime EXCLUDE_FROM_ALL $<TARGET_OBJECTS:options>
                src/fprime.cpp)
 
@@ -238,6 +233,11 @@
 add_executable(gemmi-mtz2cif EXCLUDE_FROM_ALL $<TARGET_OBJECTS:options>
                src/mtz2cif.cpp $<TARGET_OBJECTS:input> $<TARGET_OBJECTS:output>)
 support_gz(gemmi-mtz2cif)
+
+add_executable(gemmi-prep EXCLUDE_FROM_ALL $<TARGET_OBJECTS:options>
+               src/prep.cpp $<TARGET_OBJECTS:output>
+               $<TARGET_OBJECTS:input>)
+support_gz(gemmi-prep)
 
 add_executable(gemmi-reindex EXCLUDE_FROM_ALL $<TARGET_OBJECTS:options>
                src/reindex.cpp)
@@ -281,7 +281,7 @@
                src/grep.cpp src/h.cpp src/json2cif.cpp
                src/main.cpp src/map.cpp src/map2sf.cpp src/mask.cpp
                src/merge.cpp src/mondiff.cpp src/mtz.cpp src/mtz2cif.cpp
-               src/reindex.cpp src/residues.cpp src/rmsz.cpp
+               src/prep.cpp src/reindex.cpp src/residues.cpp src/rmsz.cpp
                src/sf2map.cpp src/sfcalc.cpp src/sg.cpp
                src/tags.cpp src/validate.cpp src/validate_mon.cpp src/wcn.cpp
                $<TARGET_OBJECTS:mapcoef>

=== debian/changelog ===
gemmi (0.5.4+ds-1) unstable; urgency=medium

  * New upstream version 0.5.4+ds
  * Port to tao-pegtl v3 (Closes: #1009415).
  * Drop no longer needed change_error_type_in_test.patch.
  * XS-Python-Version -> X-Python-Version.
  * Set upstream metadata fields: Repository-Browse.

 -- Andrius Merkys <merkys@debian.org>  Thu, 19 May 2022 07:00:23 -0400

=== debian/control ===
--- 
+++ 
@@ -61,7 +61,7 @@
  ${shlibs:Depends},
 Provides:
  ${python3:Provides},
-XS-Python-Version: ${python3:Versions}
+X-Python-Version: ${python3:Versions}
 Description: library for structural biology - Python module
  Library for macromolecular crystallography and structural bioinformatics. For
  working with coordinate files (mmCIF, PDB, mmJSON), refinement restraints

## gemmi 0.5.6+ds

=== debian/changelog ===
gemmi (0.5.6+ds-1) unstable; urgency=medium

  * New upstream version 0.5.6+ds
  * Run autopkgtest with gemmi executable installed.
  * Run tests and autopkgtest with NumPy.

 -- Andrius Merkys <merkys@debian.org>  Wed, 10 Aug 2022 02:08:05 -0400

gemmi (0.5.5+ds-1) unstable; urgency=medium

  * New upstream version 0.5.5+ds
  * Add reference.
  * Drop unnecessary dependency on build-essential.
  * Set upstream metadata fields: Repository.

 -- Andrius Merkys <merkys@debian.org>  Mon, 06 Jun 2022 08:24:27 -0400

=== debian/control ===
--- 
+++ 
@@ -12,6 +12,7 @@
  help2man,
  libstb-dev,
  python3-dev,
+ python3-numpy <!nocheck>,
  python3-pybind11 (>= 2.6.0),
  python3-pytest <!nocheck>,
  tao-pegtl-dev,

=== debian/tests/control ===
Test-Command: pytest-3
Depends:
 python3-numpy,
 python3-pytest,
 @,

## gemmi 0.5.7+ds

=== docs/requirements.txt ===
sphinx_rtd_theme >= 1.0.0
sphinx >= 2.4.4

=== debian/changelog ===
gemmi (0.5.7+ds-2) unstable; urgency=medium

  * Not running test_sfcalc4 autopkgtest: fails on i386 due to precision.
  * Update standards version to 4.6.1, no changes needed.

 -- Andrius Merkys <merkys@debian.org>  Tue, 04 Oct 2022 03:51:36 -0400

gemmi (0.5.7+ds-1) unstable; urgency=medium

  * New upstream version 0.5.7+ds
  * Drop upstream-integrated patches.
  * Skip overly sensitive test (Closes: #1019515).

 -- Andrius Merkys <merkys@debian.org>  Thu, 22 Sep 2022 10:02:00 -0400

gemmi (0.5.6+ds-2) unstable; urgency=medium

  * Import upstream commits to fix tests on arm64, i386 and other
    architectures.

 -- Andrius Merkys <merkys@debian.org>  Mon, 29 Aug 2022 11:51:45 -0400

=== debian/control ===
--- 
+++ 
@@ -17,7 +17,7 @@
  python3-pytest <!nocheck>,
  tao-pegtl-dev,
  zlib1g-dev,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://project-gemmi.github.io
 Vcs-Browser: https://salsa.debian.org/debichem-team/gemmi
 Vcs-Git: https://salsa.debian.org/debichem-team/gemmi.git

=== debian/rules ===
--- 
+++ 
@@ -5,14 +5,14 @@
 export PYBUILD_NAME=gemmi
 
 %:
-	dh $@ --buildsystem=cmake --with python3
+	dh $@ --buildsystem cmake --with python3
 
 override_dh_auto_configure:
 	dh_auto_configure -- -DUSE_PYTHON=1 -DINSTALL_EGG_INFO=OFF
 
 override_dh_auto_test:
 	dh_auto_build -- check
-	PYTHONPATH=$$(find . -name 'obj-*') pytest-3
+	PYTHONPATH=$$(find . -name 'obj-*') pytest-3 -k 'not test_sfcalc_'
 
 override_dh_installman: debian/gemmi.1
 	dh_installman

=== debian/tests/control ===
Test-Command: pytest-3 -k 'not test_sfcalc_ and not test_sfcalc4'
Depends:
 python3-numpy,
 python3-pytest,
 @,

## gemmi 0.6.2+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15...3.22)

# get version string from version.hpp
file(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/include/gemmi/version.hpp"
     gemmi_version_line REGEX "#define GEMMI_VERSION \"")
string(REGEX REPLACE ".+\"([0-9]+\.[0-9]+\.[0-9]+)(-dev)?\"" "\\1"
       gemmi_version_str ${gemmi_version_line})

project(gemmi LANGUAGES C CXX VERSION ${gemmi_version_str})
message(STATUS "Gemmi version ${PROJECT_VERSION}")

include(GNUInstallDirs)  # for CMAKE_INSTALL_LIBDIR

option(BUILD_SHARED_LIBS "Build using shared library" OFF)
option(BUILD_GEMMI_PROGRAM "Build gemmi command-line program" ON)
option(USE_FORTRAN "Build Fortran bindings" OFF)
option(USE_PYTHON "Build Python bindings" OFF)
option(INSTALL_EGG_INFO "Install .egg-info via setup.py" ON)
option(EXTRA_WARNINGS "Set extra warning flags" OFF)
option(USE_WMAIN "(Windows only) take Unicode arguments in gemmi program" ON)
set(GEMMI_INSTALL_CMAKEDIR "${CMAKE_INSTALL_LIBDIR}/cmake/gemmi" CACHE STRING
    "Install path for gemmi CMake files")
option(STRIP_BINARY "Strip symbols from program" OFF)

# uncomment to show compilation times for each compilation unit
#set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "\"${CMAKE_COMMAND}\" -E time")

if (DEFINED ENV{FC} OR CMAKE_Fortran_COMPILER)
  set(USE_FORTRAN ON CACHE BOOL "Build Fortran bindings" FORCE)
endif()

# this makes almost no difference
if (NOT DEFINED CMAKE_VISIBILITY_INLINES_HIDDEN)
  set(CMAKE_VISIBILITY_INLINES_HIDDEN ON)
endif()
#set(CMAKE_CXX_VISIBILITY_PRESET hidden)

# By default, use LTO for non-debug builds.
if (NOT DEFINED CMAKE_INTERPROCEDURAL_OPTIMIZATION
    # problems were reported for GCC 4.8 and LTO
    # https://github.com/pybind/pybind11/issues/1415
    AND NOT (CMAKE_COMPILER_IS_GNUCC AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.9))
  include(CheckIPOSupported)
  check_ipo_supported(RESULT is_ipo_supported OUTPUT ipo_error)
  if(is_ipo_supported)
    set(CMAKE_INTERPROCEDURAL_OPTIMIZATION_RELEASE ON)
    set(CMAKE_INTERPROCEDURAL_OPTIMIZATION_MISIZEREL ON)
  else()
    message(STATUS "Interprocedural optimization not supported: ${error}")
  endif()
endif()

if (INFO)
  set(GEMMI_VERSION_INFO ${INFO} CACHE STRING "Extra text for gemmi -V" FORCE)
endif()

if (USE_FORTRAN)
   message(STATUS "Currently, Fortran bindings are not built by cmake.")
   message(STATUS "They can be built by running make in fortran directory.")
  enable_language(Fortran)
else()
  #message(STATUS "Skipping Fortran bindings. Add -D USE_FORTRAN=1 to build them.")
endif()

if (DEFINED ENV{EXTRA_WFLAGS})
  set(EXTRA_WARNINGS ON CACHE BOOL "Set extra warning flags" FORCE)
endif()

if (NOT CMAKE_CXX_STANDARD)
  if (CMAKE_CXX20_STANDARD_COMPILE_OPTION)
    set(CMAKE_CXX_STANDARD 20)
  elseif (CMAKE_CXX17_STANDARD_COMPILE_OPTION)
    # Python bindings don't compile as C++17 in VS 2017
    if (CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
      set(CMAKE_CXX_STANDARD 14)
    else()
      set(CMAKE_CXX_STANDARD 17)
    endif()
  elseif (CMAKE_CXX11_STANDARD_COMPILE_OPTION)
    set(CMAKE_CXX_STANDARD 11)
  endif()
endif()
message(STATUS "Compiling with C++ standard: ${CMAKE_CXX_STANDARD}")
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

include(CheckIncludeFile)  # for check_include_file

if (DEFINED ENV{CXXFLAGS})
  set(USING_ENV_CXXFLAGS ON CACHE BOOL "" FORCE)
endif()

# Set default build mode (based on CMake FAQ)
if (NOT CMAKE_BUILD_TYPE AND NOT USING_ENV_CXXFLAGS)
  set(CMAKE_BUILD_TYPE Release CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
endif()

find_package(ZLIB)
if (ZLIB_FOUND)
  include_directories("${ZLIB_INCLUDE_DIR}")
else()
  message(STATUS "The build will use zlib code from third_party/zlib.")
  include_directories("${CMAKE_CURRENT_SOURCE_DIR}/third_party/zlib")
endif()
find_package(benchmark QUIET)
if (benchmark_FOUND)
  message(STATUS "Found benchmark: ${benchmark_DIR}")
else (NOT benchmark_FOUND)
  message(STATUS "Benchmarks not configured.")
endif()

include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include"
                    "${CMAKE_CURRENT_SOURCE_DIR}/third_party")

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang|GNU" AND EXTRA_WARNINGS)
  set(CMAKE_CXX_FLAGS
      "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wpedantic -Wformat=2 -Wredundant-decls -Wfloat-conversion -Wdisabled-optimization -Wshadow $ENV{EXTRA_WFLAGS}")
  message(STATUS "Build type: ${CMAKE_BUILD_TYPE}")
  string(TOUPPER "CMAKE_CXX_FLAGS_${CMAKE_BUILD_TYPE}" cxx_flags_config)
  message(STATUS "C++ flags set to: ${CMAKE_CXX_FLAGS} ${${cxx_flags_config}}")
endif()

if (CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
  #set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /Qvec-report:1")
endif()

if (USE_FORTRAN)
  if (CMAKE_Fortran_COMPILER_ID MATCHES "GNU")
    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -std=f2003 -fimplicit-none -Wall -Wextra -pedantic")
    message(STATUS "Fortran flags set to: ${CMAKE_Fortran_FLAGS}")
    set(CMAKE_Fortran_FLAGS_DEBUG "${CMAKE_Fortran_FLAGS_DEBUG} -fbounds-check")
  endif()
endif()


if (ZLIB_FOUND)
  macro(support_gz exe)
    target_link_libraries(${exe} PRIVATE ZLIB::ZLIB)
  endmacro()
else()
  add_library(ungz OBJECT
      "third_party/zlib/adler32.c"
      "third_party/zlib/crc32.c"
      "third_party/zlib/gzlib.c"
      "third_party/zlib/gzread.c"
      "third_party/zlib/inflate.c"
      "third_party/zlib/inftrees.c"
      "third_party/zlib/inffast.c"
      "third_party/zlib/zutil.c")
  check_include_file(unistd.h has_unistd_h)
  target_compile_definitions(ungz PRIVATE NO_GZCOMPRESS=1)
  if (has_unistd_h)
    target_compile_definitions(ungz PRIVATE Z_HAVE_UNISTD_H=1)
  endif()
  if (CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
    # /wd4996 - the POSIX name for this item is deprecated.
    # /wd4267 - conversion from 'size_t' to 'unsigned int', possible loss of data
    target_compile_options(ungz PRIVATE /wd4996 /wd4267)
  endif()
  set_property(TARGET ungz PROPERTY POSITION_INDEPENDENT_CODE ON)
  macro(support_gz exe)
    target_sources(${exe} PUBLIC $<TARGET_OBJECTS:ungz>)
  endmacro()
endif()

if (WIN32 AND USE_WMAIN)
  add_definitions(-D_UNICODE=1)
endif()

#add_library(cgemmi STATIC fortran/grid.cpp fortran/symmetry.cpp)
#
#if (USE_FORTRAN)
#  add_library(fgemmi STATIC fortran/gemmi.f90)
#  target_link_libraries(fgemmi PRIVATE cgemmi)
#endif()


### programs from prog/ ###

add_library(options OBJECT prog/options.cpp)
if (GEMMI_VERSION_INFO)
  target_compile_definitions(options PRIVATE GEMMI_VERSION_INFO=${GEMMI_VERSION_INFO})
endif()

add_library(gemmi_cpp
            src/assembly.cpp src/calculate.cpp src/crd.cpp src/eig3.cpp
            src/mmcif.cpp src/mmread_gz.cpp src/mtz.cpp src/mtz2cif.cpp
            src/polyheur.cpp src/read_cif.cpp src/resinfo.cpp
            src/riding_h.cpp src/sprintf.cpp src/to_mmcif.cpp
            src/to_pdb.cpp src/monlib.cpp src/topo.cpp src/xds_ascii.cpp)
set_property(TARGET gemmi_cpp PROPERTY POSITION_INDEPENDENT_CODE ON)
#set_property(TARGET gemmi_cpp PROPERTY CXX_VISIBILITY_PRESET hidden)
target_compile_definitions(gemmi_cpp PRIVATE GEMMI_BUILD)
if (BUILD_SHARED_LIBS)
  target_compile_definitions(gemmi_cpp PUBLIC GEMMI_SHARED)
endif()
support_gz(gemmi_cpp)


# Gemmi subcommands compiled as individual binaries.
# Not built by default and used mostly for testing.
function(add_single_prog target)
  cmake_parse_arguments(arg "NOLIB;GZ" "ADD_SRC" "" ${ARGN})
  add_executable(gemmi-${target} EXCLUDE_FROM_ALL prog/${target}.cpp ${arg_ADD_SRC}
                 $<TARGET_OBJECTS:options>)
  if (NOT arg_NOLIB)
    target_link_libraries(gemmi-${target} PRIVATE gemmi_cpp)
  endif()
  if (arg_GZ)
    support_gz(gemmi-${target})
  endif()
endfunction()

add_single_prog(align)
add_single_prog(blobs ADD_SRC prog/mapcoef.cpp GZ)
add_single_prog(cif2json)
add_single_prog(cif2mtz)
add_single_prog(contact)
add_single_prog(contents)
add_single_prog(convert)
add_single_prog(fprime NOLIB)
add_single_prog(grep NOLIB GZ)
add_single_prog(h)
add_single_prog(json2cif)
add_single_prog(map GZ)
add_single_prog(map2sf GZ)
add_single_prog(mask)
add_single_prog(mixmtz)
add_single_prog(merge GZ)
add_single_prog(mondiff)
add_single_prog(mtz GZ)
add_single_prog(mtz2cif GZ)
add_single_prog(prep)
add_single_prog(reindex GZ)
add_single_prog(residues)
add_single_prog(rmsz)
add_single_prog(sf2map ADD_SRC prog/mapcoef.cpp GZ)
add_single_prog(sfcalc GZ)
add_single_prog(sg NOLIB)
add_single_prog(tags NOLIB GZ)
add_single_prog(validate ADD_SRC prog/validate_mon.cpp GZ)
add_single_prog(wcn)
add_single_prog(xds2mtz GZ)

# gemmi program with a number of subcommands
add_executable(gemmi_prog
               prog/align.cpp prog/blobs.cpp
               prog/cif2mtz.cpp prog/cif2json.cpp prog/contact.cpp
               prog/contents.cpp prog/convert.cpp prog/fprime.cpp
               prog/grep.cpp prog/h.cpp prog/json2cif.cpp
               prog/main.cpp prog/map.cpp prog/map2sf.cpp
               prog/mapcoef.cpp prog/mask.cpp
               prog/merge.cpp prog/mondiff.cpp prog/mtz.cpp prog/mtz2cif.cpp
               prog/prep.cpp prog/reindex.cpp prog/residues.cpp prog/rmsz.cpp
               prog/sf2map.cpp prog/sfcalc.cpp prog/sg.cpp prog/tags.cpp
               prog/validate.cpp prog/validate_mon.cpp prog/wcn.cpp
               prog/xds2mtz.cpp
               $<TARGET_OBJECTS:options>)
target_link_libraries(gemmi_prog PRIVATE gemmi_cpp)
support_gz(gemmi_prog)
target_compile_definitions(gemmi_prog PRIVATE GEMMI_ALL_IN_ONE=1)
set_property(TARGET gemmi_prog PROPERTY OUTPUT_NAME gemmi)
if (WIN32 AND USE_WMAIN)
  # _UNICODE=1 is now set globally
  #target_compile_definitions(gemmi_prog PRIVATE _UNICODE=1)
  if(MINGW)
    # target_link_options were added in cmake 3.13
    set_property(TARGET gemmi_prog PROPERTY LINK_FLAGS "-municode")
  endif()
endif()
if (NOT BUILD_GEMMI_PROGRAM)
  set_property(TARGET gemmi_prog PROPERTY EXCLUDE_FROM_ALL TRUE)
endif()

# I'm not sure if this option should be here.
# The alternative is to use install/strip target, or cmake --install --strip.
if (STRIP_BINARY AND CMAKE_STRIP)
  add_custom_command(TARGET gemmi_prog POST_BUILD
                     COMMENT "Strip symbols from program with ${CMAKE_STRIP}"
                     COMMAND ${CMAKE_STRIP}
                     ARGS $<TARGET_FILE:gemmi_prog>)
endif()

### tests and examples ###

#add_executable(c_test EXCLUDE_FROM_ALL fortran/c_test.c)
#target_link_libraries(c_test PRIVATE cgemmi)

add_executable(cpptest EXCLUDE_FROM_ALL tests/main.cpp tests/cif.cpp
                                        src/mtz2cif.cpp src/eig3.cpp src/sprintf.cpp)
target_compile_definitions(cpptest PRIVATE USE_STD_SNPRINTF=1)

add_executable(hello EXCLUDE_FROM_ALL examples/hello.cpp)
add_executable(doc_example EXCLUDE_FROM_ALL
               docs/code/sym.cpp docs/code/elem.cpp docs/code/resinfo.cpp
               docs/code/cell.cpp src/resinfo.cpp)
add_executable(doc_example2 EXCLUDE_FROM_ALL docs/code/cif_cc.cpp)
add_executable(doc_maybegz EXCLUDE_FROM_ALL docs/code/maybegz.cpp docs/code/mutate.cpp)
target_link_libraries(doc_maybegz PRIVATE gemmi_cpp)
support_gz(doc_maybegz)
add_executable(doc_newmtz EXCLUDE_FROM_ALL docs/code/newmtz.cpp)
target_link_libraries(doc_newmtz PRIVATE gemmi_cpp)
support_gz(doc_newmtz)

# always compile these tests with assertions enabled
if (CMAKE_CXX_COMPILER_ID MATCHES "Clang|GNU|Intel")
  target_compile_options(doc_example PRIVATE -UNDEBUG)
endif()

add_executable(test_disulf EXCLUDE_FROM_ALL tests/disulf.cpp)
target_link_libraries(test_disulf PRIVATE gemmi_cpp)
support_gz(test_disulf)

# auth_label requires <experimental/filesystem> and -lstdc++fs
add_executable(auth_label EXCLUDE_FROM_ALL examples/auth_label.cpp)
if (NOT MSVC)
  target_link_libraries(auth_label PRIVATE stdc++fs)
endif()
support_gz(auth_label)

add_executable(check_conn EXCLUDE_FROM_ALL examples/check_conn.cpp)
target_link_libraries(check_conn PRIVATE gemmi_cpp)

=== debian/changelog ===
gemmi (0.6.2+ds-5) unstable; urgency=medium

  * Append -fexcess-precision=fast to CXXFLAGS to fix builds on
    i386/s390x/m68k (Closes: #1042379)

 -- Andrius Merkys <merkys@debian.org>  Mon, 31 Jul 2023 08:58:05 -0400

gemmi (0.6.2+ds-4) unstable; urgency=medium

  * Export DEB_PYTHON_INSTALL_LAYOUT = deb in debian/rules to adjust to recent
    change in CMake's Python_SITEARCH (Closes: #1042186)

 -- Andrius Merkys <merkys@debian.org>  Thu, 27 Jul 2023 01:18:39 -0400

gemmi (0.6.2+ds-3) unstable; urgency=medium

  * Fix FTBFS with GCC 13 (Closes: #1037671)

 -- Andrius Merkys <merkys@debian.org>  Fri, 14 Jul 2023 04:33:02 -0400

gemmi (0.6.2+ds-2) unstable; urgency=medium

  * Provide the static library.

 -- Andrius Merkys <merkys@debian.org>  Thu, 22 Jun 2023 05:42:54 -0400

gemmi (0.6.2+ds-1) unstable; urgency=medium

  * New upstream version 0.6.2+ds
  * Improve cleaning.

 -- Andrius Merkys <merkys@debian.org>  Mon, 12 Jun 2023 09:10:56 -0400

gemmi (0.6.1+ds-1) experimental; urgency=medium

  * New upstream version 0.6.1+ds
  * Bump copyright years.

 -- Andrius Merkys <merkys@debian.org>  Tue, 02 May 2023 02:26:06 -0400

gemmi (0.6.0+ds-1) experimental; urgency=medium

  * New upstream version 0.6.0+ds
  * Refresh use-system-tao-pegtl.patch.
  * Adjust installation paths, not installing the static library.

 -- Andrius Merkys <merkys@debian.org>  Tue, 28 Mar 2023 06:57:38 -0400

gemmi (0.5.8+ds-1) experimental; urgency=medium

  * New upstream version 0.5.8+ds
  * Update standards version to 4.6.2, no changes needed.

 -- Andrius Merkys <merkys@debian.org>  Fri, 23 Dec 2022 02:18:31 -0500

=== debian/rules ===
--- 
+++ 
@@ -2,7 +2,10 @@
 
 include /usr/share/dpkg/pkg-info.mk
 
-export PYBUILD_NAME=gemmi
+export PYBUILD_NAME = gemmi
+export DEB_PYTHON_INSTALL_LAYOUT = deb
+
+export DEB_CXXFLAGS_MAINT_APPEND = -fexcess-precision=fast # See #1042379
 
 %:
 	dh $@ --buildsystem cmake --with python3
@@ -14,6 +17,9 @@
 	dh_auto_build -- check
 	PYTHONPATH=$$(find . -name 'obj-*') pytest-3 -k 'not test_sfcalc_'
 
+execute_after_dh_auto_clean:
+	rm -rf .pytest_cache examples/__pycache__ tests/__pycache__
+
 override_dh_installman: debian/gemmi.1
 	dh_installman

## gemmi 0.6.3+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -188,7 +188,8 @@
 endif()
 
 add_library(gemmi_cpp
-            src/assembly.cpp src/calculate.cpp src/crd.cpp src/eig3.cpp
+            src/assembly.cpp src/calculate.cpp src/crd.cpp
+            src/ddl.cpp src/eig3.cpp
             src/mmcif.cpp src/mmread_gz.cpp src/mtz.cpp src/mtz2cif.cpp
             src/polyheur.cpp src/read_cif.cpp src/resinfo.cpp
             src/riding_h.cpp src/sprintf.cpp src/to_mmcif.cpp
@@ -223,6 +224,7 @@
 add_single_prog(contact)
 add_single_prog(contents)
 add_single_prog(convert)
+add_single_prog(ecalc GZ)
 add_single_prog(fprime NOLIB)
 add_single_prog(grep NOLIB GZ)
 add_single_prog(h)
@@ -235,7 +237,7 @@
 add_single_prog(mondiff)
 add_single_prog(mtz GZ)
 add_single_prog(mtz2cif GZ)
-add_single_prog(prep)
+add_single_prog(prep ADD_SRC prog/monlib_opt.cpp GZ)
 add_single_prog(reindex GZ)
 add_single_prog(residues)
 add_single_prog(rmsz)
@@ -251,11 +253,12 @@
 add_executable(gemmi_prog
                prog/align.cpp prog/blobs.cpp
                prog/cif2mtz.cpp prog/cif2json.cpp prog/contact.cpp
-               prog/contents.cpp prog/convert.cpp prog/fprime.cpp
+               prog/contents.cpp prog/convert.cpp
+               prog/ecalc.cpp prog/fprime.cpp
                prog/grep.cpp prog/h.cpp prog/json2cif.cpp
                prog/main.cpp prog/map.cpp prog/map2sf.cpp
-               prog/mapcoef.cpp prog/mask.cpp
-               prog/merge.cpp prog/mondiff.cpp prog/mtz.cpp prog/mtz2cif.cpp
+               prog/mapcoef.cpp prog/mask.cpp prog/merge.cpp
+               prog/mondiff.cpp prog/monlib_opt.cpp prog/mtz.cpp prog/mtz2cif.cpp
                prog/prep.cpp prog/reindex.cpp prog/residues.cpp prog/rmsz.cpp
                prog/sf2map.cpp prog/sfcalc.cpp prog/sg.cpp prog/tags.cpp
                prog/validate.cpp prog/validate_mon.cpp prog/wcn.cpp
@@ -321,8 +324,3 @@
 if (NOT MSVC)
   target_link_libraries(auth_label PRIVATE stdc++fs)
 endif()
-support_gz(auth_label)
-
-add_executable(check_conn EXCLUDE_FROM_ALL examples/check_conn.cpp)
-target_link_libraries(check_conn PRIVATE gemmi_cpp)
-

=== debian/changelog ===
gemmi (0.6.3+ds-1) unstable; urgency=medium

  * New upstream version 0.6.3+ds
  * Drop 9c668e726c4b8fb57330a15b53d630351808fcfa.patch: integrated upstream.

 -- Andrius Merkys <merkys@debian.org>  Mon, 11 Sep 2023 04:26:20 -0400
